#ifndef __ABLIB_ISKANJI_H__
#define __ABLIB_ISKANJI_H__

namespace ablib{

inline bool IsKanji(char c){return ::IsDBCSLeadByte(c) != FALSE;}
inline bool IsKanji2(const char *str,intptr_t n){
	ASSERT(n >= 0);
	if(n == 0)return false;
	intptr_t i = n;
	do{
		if(!IsKanji(str[i - 1]))break;
		--i;
	}while(i > 0);
	return (n - i) % 2 ? true : false;
}

}//namespace ablib

#endif //__ABLIB_ISKANJI_H__

