#pragma once

namespace ablib{

template<typename T> struct SmallBuffer{
	SmallBuffer() : buf(NULL),size(0){}
	~SmallBuffer(){delete[] buf;}
	void Alloc(size_t s){
		if(s > size || buf == NULL){
			delete[] buf;
			buf = new T[2*s];
			size = 2*s;
		}
	}
	T *buf;
	size_t size;
};

}
