#ifndef __ABLIB_BIND_H__
#define __ABLIB_BIND_H__

#include "macro/repeat.h"
#include "macro/cat.h"
#include "function.h"
#include "arg.h"

/* bind̎DboostƓ悤ɓ悤ɂĂ܂D{ǂ񂯂ǁD
啪l̔\͂𒴂ĂD̂ł܂MȂD

bindĂяoꂽۂɂbindlistDɂ͓nꂽi[D
ablib::arg<N>^Cv͂̂܂܊i[C̑value<T>ƂĊi[Dt1,t2,...ƂĂD
Ԃ^bind_t^DɂbindlistƂƂƂȂ֐i[D

bind_t::operator()Ă΂arglistDnꂽ͈[arglistɊi[D
bindlist::operator()Ɋ֐arglistnČĂяoD

bindlist::operator()f(arglist[t1],arglist[t2],...)ĂяoD
arglist::operator[]arg<N>^ȂɕێĂԂCłȂȂ炻̂܂ܕԂD
ClXg\ɂ邽߁Cbind_t^󂯎͂bind_tĂяoiɈ͎󂯎ĂIj߂lԂD

C++WȂĖāCVC++7.0ŃRpCo悤ɁCƂlĂ܂D
*/

namespace ablib{
namespace bind_detail{

//bind߂lDŎĝłŐ錾̂݁D
template<typename R,typename F,typename BindList> class bind_t;

//T1 t1,T2 t2,...,Tn tn
#define ABLIB_FUNC_PARAM(n) T ## n t ## n,
#define ABLIB_FUNC_PARAMS(n) ABLIB_REPEAT_4(n,ABLIB_FUNC_PARAM) T ## n t ## n

//t1,t2,...,tn
#define ABLIB_FUNC_ARG(n) t ## n,
#define ABLIB_FUNC_ARGS(n) ABLIB_REPEAT_4(n,ABLIB_FUNC_ARG) t ## n

//, typename T1,typename T2,...,typename Tn
#define ABLIB_TEMPLATE_PARAM(n) typename T ## n,
#define ABLIB_TEMPLATE_PARAMS(n) , ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_PARAM) typename T ## n

//typename T1,typename T2,...,typename Tn
#define ABLIB_TEMPLATE_PARAMS2(n) ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_PARAM) typename T ## n

//,T1,T2,...,Tn
#define ABLIB_TEMPLATE_ARG(n) T ## n,
#define ABLIB_TEMPLATE_ARGS(n) , ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_ARG) T ## n

//T1,T2,...,Tn
#define ABLIB_TEMPLATE_ARGS2(n) ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_ARG) T ## n

//bindlist̂arg<N>value<T>ȂD
template<class T> class value{
public:
	value(T v) : m_val(v){};
	operator T(){return m_val;}
private:
	T m_val;
};

//add_value<T>::typeTarg^Ȃ炻̂܂܁CłȂvalue<T>ԂD
template<class T> struct add_value{
	typedef typename value<T> type;
};
template<int N> struct add_value<arg<N> >{
	typedef typename arg<N> type;
};

/* bindlistN̓oChꂽƊ֐ێD^value<T>^D
*/
template<typename R> class bindlist0{
public:
	explicit bindlist0(){};
	template<typename F,typename A> R operator()(F &f,A &a){return f();}
};

#define ABLIB_CREATE_BINDLIST(n) \
template<typename R ABLIB_TEMPLATE_PARAMS(n)> class bindlist ## n{				\
public:																			\
	explicit bindlist ## n(ABLIB_FUNC_PARAMS(n)) ABLIB_LIST_INITS(n){}			\
	template<typename F,typename A> R operator()(F &f,A &a){					\
		return f(ABLIB_LIST_ARGS(n));											\
	}																			\
private:																		\
	ABLIB_LIST_MEMBERS(n)														\
};																				\

/* arglistNbindꂽ֐ĂяoꂽۂɈꎞIɈێCarg<N>^ւ̕ϊsD
*/
class arglist0{
public:
	explicit arglist0(){};
	template<typename R,typename F,typename B> R operator[](bind_t<R,F,B> &b){return b();}
	template<typename T> T operator[](value<T> v){return v;}
};

#define ABLIB_CREATE_ARGLIST(n) \
template<ABLIB_TEMPLATE_PARAMS2(n)> class arglist ## n{							\
public:																			\
	explicit arglist ## n(ABLIB_FUNC_PARAMS(n)) ABLIB_LIST_INITS(n){}			\
	ABLIB_ARG_OPERATORSDEF(n)													\
	template<typename T> T operator[](value<T> v){return v;}					\
	template<typename R,typename F,typename B> R operator[](bind_t<R,F,B> &b){	\
		return b(ABLIB_LIST_MEMBER_ARGS(n));									\
	}																			\
private:																		\
	ABLIB_LIST_MEMBERS(n)														\
};																				\


//T1 operator[](ablib::arg<1>)return m_t1;} ... Tn operator[](ablib::arg<n>)(return m_tn;}
#define ABLIB_ARG_OPERATORDEF(n) T ## n operator[](ablib::arg< n >){return m_t ## n;}
#define ABLIB_ARG_OPERATORSDEF(n) ABLIB_REPEAT_4(n,ABLIB_ARG_OPERATORDEF) ABLIB_ARG_OPERATORDEF(n)

// : m_t1(t1),m_t2(t2),...,m_tn(tn)
#define ABLIB_LIST_INIT(n) m_t ## n(t ## n),
#define ABLIB_LIST_INITS(n) : ABLIB_REPEAT_4(n,ABLIB_LIST_INIT) m_t ## n(t ## n)

//T1 m_t1;... Tn m_tn;
#define ABLIB_LIST_MEMBER(n)T ## n m_t ## n;
#define ABLIB_LIST_MEMBERS(n) ABLIB_REPEAT_4(n,ABLIB_LIST_MEMBER) ABLIB_LIST_MEMBER(n)

//a[m_t1],...,a[m_tn]
#define ABLIB_LIST_ARG(n) a[m_t ## n],
#define ABLIB_LIST_ARGS(n) ABLIB_REPEAT_4(n,ABLIB_LIST_ARG) a[m_t ## n]

//T1 t1,T2 t2,...,Tn tn
#define ABLIB_FUNC_PARAM2(n) T ## n t ## n,
#define ABLIB_FUNC_PARAMS2(n) ABLIB_REPEAT_4(n,ABLIB_FUNC_PARAM2) T ## n t ## n

//m_t1,m_t2,...,m_tn
#define ABLIB_LIST_MEMBER_ARG(n) m_t ## n,
#define ABLIB_LIST_MEMBER_ARGS(n) ABLIB_REPEAT_4(n,ABLIB_LIST_MEMBER_ARG) m_t ## n

//LIST^쐬[D
ABLIB_REPEAT(ABLIB_FUNCTION_ARGC,ABLIB_CREATE_BINDLIST)
ABLIB_REPEAT(ABLIB_FUNCTION_ARGC,ABLIB_CREATE_ARGLIST)


#define ABLIB_BINDT_OPERATOR(n)	\
template<ABLIB_TEMPLATE_PARAMS2(n)>										\
Result operator()(ABLIB_FUNC_PARAMS2(n)){								\
	arglist ## n<ABLIB_TEMPLATE_ARGS2(n)> a(ABLIB_FUNC_ARGS(n));		\
	return m_l(m_f,a);													\
}																		\

/** bind^̖߂lDbindlistێD
* operator()Ăяoarglist쐬CɎĂbindlistɓnĂƂ̊֐ĂяoD
*/
template<typename R,typename F,typename BindList> class bind_t{
public:
	typedef R Result;
	bind_t(const bind_t &b) : m_f(b.m_f),m_l(b.m_l){}
	bind_t(const F &f,BindList const &l) : m_f(f),m_l(l){}

	Result operator()(){
		arglist0 a;
		return m_l(m_f,a);
	}
	
	ABLIB_REPEAT(ABLIB_FUNCTION_ARGC,ABLIB_BINDT_OPERATOR)
	
private:
	F m_f;
	BindList m_l;
};

}//namespace bind_detail

//add_value<T1>::type,add_value<T2>::type,...,add_value<Tn>::type
#define ABLIB_ADDVALUE(n) typename bind_detail::add_value<T ## n>::type,
#define ABLIB_ADDVALUES(n) ABLIB_REPEAT_4(n,ABLIB_ADDVALUE) typename bind_detail::add_value<T ## n>::type

//S1,S2,...,Sn
#define ABLIB_TEMPLATE_ARG_S(n) S ## n,
#define ABLIB_TEMPLATE_ARGS_S(n) ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_ARG_S) S ## n

//, typename S1,typename S2,...,typename Sn
#define ABLIB_TEMPLATE_PARAM_S(n) typename S ## n,
#define ABLIB_TEMPLATE_PARAMS_S(n) , ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_PARAM_S) typename S ## n

//҂ɑ҂bind֐̒`Dablib::functionpCʏ̊֐|C^ppӂĂ܂D
//pƂbind<type>(func)ƂĂяoƓ{܂Dbind<type>(func)ŁD
//result_type̒`ꂽNXłƎv̂ǁCRpCG[ƂꂽccD
template<typename R,typename F> bind_detail::bind_t<R,F,bind_detail::bindlist0<R> > bind(const F &f){
	typedef bind_detail::bindlist0<R> bindlist_type;
	return bind_detail::bind_t<R,F,bindlist_type>(f,bindlist_type());
}
template<typename R> bind_detail::bind_t<R,function0<R>,bind_detail::bindlist0<R> > bind(const function0<R> &f){
	typedef bind_detail::bindlist0<R> bindlist_type;
	return bind_detail::bind_t<R,function0<R>,bindlist_type>(f,bindlist_type());
}
template<typename R> bind_detail::bind_t<R,R (*)(),bind_detail::bindlist0<R> > bind(const R (* f)()){
	typedef bind_detail::bindlist0<R> bindlist_type;
	typedef R (*F)();
	return bind_detail::bind_t<R,F,bindlist_type>(f,bindlist_type());
}


#define ABLIB_BIND_CREATE(n)	\
template<typename R,typename F ABLIB_TEMPLATE_PARAMS(n)>								\
bind_detail::bind_t<R,F,bind_detail::bindlist ## n<R , ABLIB_ADDVALUES(n)> > 			\
bind(const F &f , ABLIB_FUNC_PARAMS(n)){												\
	typedef typename bind_detail::bindlist ## n<R , ABLIB_ADDVALUES(n)> bindlist_type;	\
	return bind_detail::bind_t<R,F,bindlist_type>(f,bindlist_type(ABLIB_FUNC_ARGS(n)));	\
}																						\
template<typename R ABLIB_TEMPLATE_PARAMS(n) ABLIB_TEMPLATE_PARAMS_S(n)>				\
bind_detail::bind_t<R,function ## n<R,ABLIB_TEMPLATE_ARGS_S(n)>,						\
bind_detail::bindlist ## n<R , ABLIB_ADDVALUES(n)> >									\
bind(const function ## n<R,ABLIB_TEMPLATE_ARGS_S(n)> &f , ABLIB_FUNC_PARAMS(n)){		\
	typedef typename bind_detail::bindlist ## n<R , ABLIB_ADDVALUES(n)> bindlist_type;	\
	typedef typename function ## n<R,ABLIB_TEMPLATE_ARGS_S(n)> F;						\
	return bind_detail::bind_t<R,F,bindlist_type>(f,bindlist_type(ABLIB_FUNC_ARGS(n)));	\
}																						\
template<typename R ABLIB_TEMPLATE_PARAMS(n) ABLIB_TEMPLATE_PARAMS_S(n)>				\
bind_detail::bind_t<R,R (*)(ABLIB_TEMPLATE_ARGS_S(n)),									\
bind_detail::bindlist ## n<R,ABLIB_ADDVALUES(n)> >										\
bind(R (*f)(ABLIB_TEMPLATE_ARGS_S(n)),ABLIB_FUNC_PARAMS(n)){							\
	typedef typename bind_detail::bindlist ## n<R,ABLIB_ADDVALUES(n)> bindlist_type;	\
	typedef typename R (*F)(ABLIB_TEMPLATE_ARGS_S(n));									\
	return bind_detail::bind_t<R,F,bindlist_type>(f,bindlist_type(ABLIB_FUNC_ARGS(n)));	\
}																						\


ABLIB_REPEAT(ABLIB_FUNCTION_ARGC,ABLIB_BIND_CREATE)

#undef ABLIB_FUNC_PARAM
#undef ABLIB_FUNC_PARAMS
#undef ABLIB_FUNC_ARG
#undef ABLIB_FUNC_ARGS
#undef ABLIB_TEMPLATE_PARAM
#undef ABLIB_TEMPLATE_PARAMS
#undef ABLIB_TEMPLATE_PARAMS2
#undef ABLIB_TEMPLATE_ARG
#undef ABLIB_TEMPLATE_ARGS
#undef ABLIB_TEMPLATE_ARGS2
#undef ABLIB_CREATE_BINDLIST
#undef ABLIB_CREATE_ARGLIST
#undef ABLIB_ARG_OPERATORDEF
#undef ABLIB_ARG_OPERATORSDEF
#undef ABLIB_LIST_INIT
#undef ABLIB_LIST_INITS
#undef ABLIB_LIST_MEMBER
#undef ABLIB_LIST_MEMBERS
#undef ABLIB_LIST_ARG
#undef ABLIB_LIST_ARGS
#undef ABLIB_LIST_MEMBER_ARG
#undef ABLIB_LIST_MEMBER_ARGS
#undef ABLIB_FUNC_PARAM2
#undef ABLIB_FUNC_PARAMS2
#undef ABLIB_BINDT_OPERATOR
#undef ABLIB_ADDVALUE
#undef ABLIB_ADDVALUES
#undef ABLIB_TEMPLATE_ARG_S
#undef ABLIB_TEMPLATE_ARGS_S
#undef ABLIB_TEMPLATE_PARAM_S
#undef ABLIB_TEMPLATE_PARAMS_S
#undef ABLIB_BIND_CREATE


}//namespace ablib



#endif //__ABLIB_BIND_H__

