#ifndef __ABLIB_WINDOW_SUBCLASSWND_H__
#define __ABLIB_WINDOW_SUBCLASSWND_H__

#include <vector>
#include <memory>
#include "window.h"
#include "dialog.h"

/* TuNX̂߂̃NXDhĎgD
* SubClass(hwnd)ŃTuNXJnDUnSubCLass()ŏID
* BaseWndƂɂAddSubClassĂ̂̂ŁCœo^ĂƃEBhE/j󎞂ɏɂĂD
* EBhEƂɃCX^Xpӂ邱ƁD
*/

namespace ablib{
namespace window{

class SubClassDlg{
public:
	SubClassDlg() : m_oldproc(NULL){}
	~SubClassDlg(){}

	std::shared_ptr<ablib::window::Dialog> GetWindow(){return m_dialog;}

//private:
	void SubClass(HWND hwnd);
	void UnSubClass();
private:
	friend class BaseWnd;
	friend class BaseModalDlg;
	friend class BaseDlg;

protected:
	/// _CAO
	virtual bool OnInitDialog(Dialog *wnd){return false;}
	/// I
	virtual bool OnClose(Dialog *wnd){return false;}
	virtual bool OnDestroy(Dialog *wnd){return false;}
	/// tH[JX𓾂
	virtual bool OnSetFocus(Dialog *wnd,Dialog *old){return false;}
	/// tH[JXD
	virtual bool OnKillFocus(Dialog *wnd,Dialog *New){return false;}
	/// }EX
	virtual bool OnMouseMove(Dialog *wnd,Mouse *mos, intptr_t keyFlags){return false;}
	/// {^ꂽD
	virtual bool OnLButtonDown(Dialog *wnd,Mouse *mos,bool isDClick){return false;}
	/// {^
	virtual bool OnLButtonUp(Dialog *wnd,Mouse *mos){return false;}
	/// E{^ꂽ
	virtual bool OnRButtonDown(Dialog *wnd,Mouse *mos,bool isDClick){return false;}
	/// E{^
	virtual bool OnRButtonUp(Dialog *wnd,Mouse *mos){return false;}
	/// ^񒆃{^ꂽ
	virtual bool OnMButtonDown(Dialog *wnd,Mouse *mos,bool isDClick){return false;}
	/// ^񒆃{^
	virtual bool OnMButtonUp(Dialog *wnd,Mouse *mos){return false;}
	/// 肭
	virtual bool OnMouseWheel(Dialog *wnd,Mouse *mos, intptr_t delta){return false;}
	/// L[ꂽ
	virtual bool OnKey(Dialog *wnd,bool isDown,UINT vk,intptr_t repeat){return false;}
	/// WM_CHAR
	virtual bool OnChar(Dialog *wnd,TCHAR ch, intptr_t repeat){return false;}
	/// R}h
	virtual bool OnCommand(Dialog *wnd,int id, intptr_t param){return false;}
	/// OnNotify
	virtual bool OnNotify(Dialog *wnd,NMHDR *nmhdr,LRESULT &rv){return false;}
	
	/// ̑iȂꍇCDefaultProcĂԂƁj
	virtual INT_PTR OnOtherMessage(Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){return DefaultProc(msg,wParam,lParam);}
	
	/// bZ[WO
	virtual bool PreTranslateMessage(Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam,INT_PTR &rv){return false;}

	INT_PTR DefaultProc(UINT msg,WPARAM wParam,LPARAM lParam){
		return ::CallWindowProc(m_oldproc,m_dialog->GetHWND(),msg,wParam,lParam);
	}
	
private:
	BOOL Atach(HWND hwnd){return ::SetProp(hwnd,_T("ABENORI_WINDOW_PROP"),reinterpret_cast<HANDLE>(this));}
	HANDLE Detach(HWND hwnd){return ::RemoveProp(hwnd,_T("ABENORI_WINDOW_PROP"));}
	WNDPROC m_oldproc;
	static INT_PTR CALLBACK sDlgProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
	std::shared_ptr<Dialog> m_dialog;
};

}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_SUBCLASS_H__

