#ifndef __ABLIB_WINDOW_STDAFX_H__
#define __ABLIB_WINDOW_STDAFX_H__

//UNICODEłɂ͂̃RgAEgO
//#define UNICODE

#ifdef UNICODE
#define _UNICODE
#endif

#include <windows.h>
#include <tchar.h>
#include <commctrl.h>

//͎g܂
#include "../ablib/string.h"

//Rs[֎~
#define NOCOPY(T) T( const T& ); T& operator=( const T& )

//[
#ifndef ASSERT
	#ifdef NDEBUG
		#define ASSERT(C)
	#else
		#include <assert.h>
		#define ASSERT(C) assert(C)
	#endif
#endif

//ł΂p
#ifndef __DEBUGSTRING__
	#define __DEBUGSTRING__
	#ifdef NDEBUG
		inline void DEBUGSTRING(const TCHAR *fmt,...){}
	#else
		#include <stdarg.h>
		#include <stdio.h>
		inline void DEBUGSTRING(const TCHAR *fmt,...){
			va_list args;
			va_start(args,fmt);
			int size = ::_vsctprintf(fmt,args);
			TCHAR *buf = new TCHAR[size + 1];
			if(buf){
				::_vstprintf(buf,fmt,args);
				::OutputDebugString(buf);
				::OutputDebugString(_T("\n"));
				delete[] buf;
			}
			va_end(args);
		}
	#endif
#endif

//Ȃ񂩂ȂČ́cc
#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL 0x020A
#endif
#ifndef WHEEL_DELTA
#define WHEEL_DELTA 120
#endif


#endif //__ABLIB_WINDOW_STDAFX_H__