#ifndef __ABLIB_PATHNAME_H__
#define __ABLIB_PATHNAME_H__

namespace ablib{
class Pathname{
public:
	Pathname(const ablib::string &file);
	ablib::string dirname() const{return m_dir;}
	ablib::string basename() const{return m_base;}
	ablib::string filetype() const{return m_type;}

private:
	ablib::string m_dir,m_base,m_type;

	ablib::string RegularPath(const ablib::string &path);
};
} //namespace ablib	

#endif //__ABLIB_PATHNAME_H__

