#ifndef __ABLIB_H__
#define __ABLIB_H__

#ifndef _UNICODE
#ifdef UNICODE
#define _UNICODE
#endif
#endif

#ifndef UNICODE
#ifdef _UNICODE
#define UNICODE
#endif
#endif


/*
FXƎǵDSTL̋UD{gĂȁi΁j

VC++ȊÕRpCœC͑SR܂D
*/

#ifndef NDEBUG
#ifndef _CRTDBG_MAP_ALLOC
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#endif
#endif

#include <windows.h>
#include <tchar.h>
#include <string>
//#include <stddef.h>//size_t̒`ق

//Rs[֎~
#ifndef NOCOPY
#define NOCOPY(T) T( const T& ); T& operator=( const T& )
#endif

//min,max
template<typename T> T Max(T a,T b){return (a > b ? a : b);}
template<typename T> T Min(T a,T b){return (a < b ? a : b);}

#include "string.h"

//[
#ifndef __ABENORI_ASSERT__
#define __ABENORI_ASSERT__
	#ifdef NDEBUG
		template<typename C> void ASSERT(C c){}
	#else
		#include <assert.h>
		template<typename C> void ASSERT(C c){assert(c);}
	#endif
#endif

//ł΂p
#ifndef __DEBUGSTRING__
	#define __DEBUGSTRING__
	#ifdef NDEBUG
		inline void DEBUGSTRINGA(const char *fmt,...){}
		inline void DEBUGSTRINGW(const wchar_t *fmt,...){}
	#else
		#include <stdarg.h>
		#include <stdio.h>
		inline void DEBUGSTRINGA(const char *fmt,...){
			va_list args;
			va_start(args,fmt);
			int size = ::_vscprintf(fmt,args);
			char *buf = new char[size + 1];
			if(buf){
				::vsprintf(buf,fmt,args);
				::OutputDebugStringA(buf);
				::OutputDebugStringA("\n");
				delete[] buf;
			}
			va_end(args);
		}
		inline void DEBUGSTRINGW(const wchar_t *fmt,...){
			va_list args;
			va_start(args,fmt);
			int size = ::_vscwprintf(fmt,args);
			wchar_t *buf = new wchar_t[size + 1];
			if(buf){
				::vswprintf(buf, size + 1, fmt, args);
				::OutputDebugStringW(buf);
				::OutputDebugStringW(L"\n");
				delete[] buf;
			}
			va_end(args);
		}
	#endif
#endif

#ifdef UNICODE
#define DEBUGSTRING DEBUGSTRINGW
#else
#define DEBUGSTRING DEBUGSTRINGA
#endif

//#define _CRT_SECURE_NO_WARNINGS
#ifndef __LASTERROR_OUTPUT__
	#define __LASTERROR_OUTPUT__
	#ifdef NDEBUG
		inline void OUTPUTLASTERROR(DWORD err = 0){};
	#else
		inline void OUTPUTLASTERROR(DWORD err = ::GetLastError()){
			TCHAR buf[4096],buf2[4096];
			::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 0, err,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), buf, 4095, 0);
			::_stprintf_s(buf2,4095,_T("%d: %s"),err,buf);
			::OutputDebugString(buf2);
		}
	#endif
#endif

#endif //__ABLIB_H__

