#ifndef __ABLIB_WINDOW_STDAFX_H__
#define __ABLIB_WINDOW_STDAFX_H__

/**
* EBhE֘A܂Ƃ߂CuD
* R[fBOʂ̌yړID
*
* Ƃn߂đ啪ĂATL/WTL𔭌D
* ccɂ͂ЂȂCdȂiŁj
*/

#ifndef NDEBUG
#ifndef _CRTDBG_MAP_ALLOC
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#endif
#endif

#include <windows.h>
#include <tchar.h>
#include <commctrl.h>
#include <Shlobj.h>

//͎g܂
#include "../ablib/string.h"

//Rs[֎~
#define NOCOPY(T) T( const T& ); T& operator=( const T& )

//[
#ifndef __ABENORI_ASSERT__
#define __ABENORI_ASSERT__
	#ifdef NDEBUG
		template<typename C> void ASSERT(C c){}
	#else
		#include <assert.h>
		template<typename C> void ASSERT(C c){assert(c);}
	#endif
#endif

//ł΂p
#ifndef __DEBUGSTRING__
	#define __DEBUGSTRING__
	#ifdef NDEBUG
		inline void DEBUGSTRING(const TCHAR *fmt,...){}
	#else
		#include <stdarg.h>
		#include <stdio.h>
		inline void DEBUGSTRING(const TCHAR *fmt,...){
			va_list args;
			va_start(args,fmt);
			int size = ::_vsctprintf(fmt,args);
			TCHAR *buf = new TCHAR[size + 1];
			if(buf){
				::_vstprintf(buf,fmt,args);
				::OutputDebugString(buf);
				::OutputDebugString(_T("\n"));
				delete[] buf;
			}
			va_end(args);
		}
	#endif
#endif

#ifndef __LASTERROR_OUTPUT__
	#define __LASTERROR_OUTPUT__
	#ifdef NDEBUG
		inline void OUTPUTLASTERROR(){};
	#else
		inline void OUTPUTLASTERROR(DWORD err = ::GetLastError()){
			TCHAR buf[4096];
			::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 0, err,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), buf, 4095, 0);
			::OutputDebugString(buf);
		}
	#endif
#endif

//Ȃ񂩂ȂČ́cc
#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL 0x020A
#endif
#ifndef WHEEL_DELTA
#define WHEEL_DELTA 120
#endif

namespace ablib{
namespace window{
DWORD GetLastError();
void SetLastError(DWORD code);
void SetLastError();
}
}

#endif //__ABLIB_WINDOW_STDAFX_H__

